/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class ZAEHLER {\n    int anzahl;\n    void zuruecksetzen() {\n        this.anzahl = 0;\n    }\n    void einsMehr() {\n        this.anzahl = this.anzahl + 1;\n    }\n    int getAnzahl() {\n        return this.anzahl;\n    }\n}\n\nZAEHLER stifte = new ZAEHLER();\nZAEHLER lineale = new ZAEHLER();\nstifte.einsMehr();\nlineale.einsMehr();\nstifte.zuruecksetzen();\nif (stifte.getAnzahl() == 0) {\n    stifte.einsMehr();\n}\nlineale.einsMehr();\nprint(stifte.getAnzahl());\nprint(\" Stift(e) und \");\nprint(lineale.getAnzahl());\nprint(\" Lineal(e)\");",
	"classes": [
		{
			"className": "ZAEHLER",
			"atts": [
				{
					"key": "anzahl",
					"type": "int",
					"value": 0
				}
			]
		}
	],
	"notSelectable": [
		4,
		7,
		10,
		11,
		12,
		20
	],
	"methodCalls": [
		2,
		5,
		8
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "ZAEHLER"
		}
	],
	"steps": [
		{
			"task": "Führe stets die hervorgehobene Zeile aus: Trage Auswirkungen in die Speichertabelle bzw. die Textausgabe ein, sofern nötig. Wähle dann die als nächstes auszuführende Zeile aus.",
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			},
			"cout": "",
			"allowArrays": false,
			"enableOverload": false,
			"autoremoveGarbage": false,
			"enableTextOut": true
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 16,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 16,
						"vars": [
							{
								"key": "this",
								"ref": 4
							}
						]
					}
				]
			}
		},
		{
			"line": 17,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 3,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 17,
						"vars": [
							{
								"key": "this",
								"ref": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 18,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 18,
						"vars": [
							{
								"key": "this",
								"ref": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 19,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 19,
						"vars": [
							{
								"key": "this",
								"ref": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 21,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 21,
						"vars": [
							{
								"key": "this",
								"ref": 4
							}
						]
					}
				]
			}
		},
		{
			"line": 22,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 22,
						"vars": [
							{
								"key": "this",
								"ref": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 23,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			},
			"cout": "1"
		},
		{
			"line": 24,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			},
			"cout": "1 Stift(e) und "
		},
		{
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			}
		},
		{
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 24,
						"vars": [
							{
								"key": "this",
								"ref": 4
							}
						]
					}
				]
			}
		},
		{
			"line": 25,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			},
			"cout": "1 Stift(e) und 2"
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 2
							}
						],
						"pointer": 4
					},
					{
						"instance": "object",
						"className": "ZAEHLER",
						"atts": [
							{
								"key": "anzahl",
								"type": "int",
								"value": 1
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "stifte",
						"type": "ZAEHLER",
						"ref": 8
					},
					{
						"key": "lineale",
						"type": "ZAEHLER",
						"ref": 4
					}
				],
				"scopes": []
			},
			"cout": "1 Stift(e) und 2 Lineal(e)"
		}
	]
};
